<?php
require_once './dbconnection.php'; 
header('Content-Type: application/json');


if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    

    $firstname = isset($_POST['firstname']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['firstname'])) : null;
    $lastname = isset($_POST['lastname']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['lastname'])) : null;
    $gender = isset($_POST['gender']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['gender'])) : null;
    $dateofbirth = isset($_POST['dateofbirth']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['dateofbirth'])) : null;
    $height = isset($_POST['height']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['height'])) : null;
    $maritalstatus = isset($_POST['maritalstatus']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['maritalstatus'])) : null;
    $religion = isset($_POST['religion']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['religion'])) : null;
    $religionlookingfor = isset($_POST['religionlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['religionlookingfor'])) : null;
    $nationality = isset($_POST['nationality']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['nationality'])) : null;
    $nationalitylookingfor = isset($_POST['nationalitylookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['nationalitylookingfor'])) : null;
    $education = isset($_POST['education']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['education'])) : null;
    $educationlookingfor = isset($_POST['educationlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['educationlookingfor'])) : null;
    $city = isset($_POST['city']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['city'])) : null;
    $citylookingfor = isset($_POST['citylookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['citylookingfor'])) : null;
    $cast = isset($_POST['cast']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['cast'])) : null;
    $castlookingfor = isset($_POST['castlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['castlookingfor'])) : null;
    $subcast = isset($_POST['subcast']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['subcast'])) : null;
    $subcastlookingfor = isset($_POST['subcastlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['subcastlookingfor'])) : null;
    $sect = isset($_POST['sect']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['sect'])) : null;
    $sectlookingfor = isset($_POST['sectlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['sectlookingfor'])) : null;
    $subsect = isset($_POST['subsect']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['subsect'])) : null;
    $subsectlookingfor = isset($_POST['subsectlookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['subsectlookingfor'])) : null;
    $ethnicity = isset($_POST['ethnicity']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['ethnicity'])) : null;
    $ethnicitylookingfor = isset($_POST['ethnicitylookingfor']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['ethnicitylookingfor'])) : null;

   
    if (isset($_FILES['profileimage'])) {
        $targetDir = "uploads/";  
        $fileName = basename($_FILES["profileimage"]["name"]);
        $targetFile = $targetDir . $fileName;
        $imageFileType = strtolower(pathinfo($targetFile, PATHINFO_EXTENSION));
        
        $allowedFileTypes = array("jpg", "jpeg", "png", "gif");
        if (in_array($imageFileType, $allowedFileTypes)) {
            if (move_uploaded_file($_FILES["profileimage"]["tmp_name"], $targetFile)) {
  
                $profileImageUrl =  $targetFile; 
            } else {
                $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "Error uploading the image.");
                echo json_encode($response);
                exit;
            }
        } else {
            $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "Invalid image type. Only JPG, JPEG, PNG, GIF are allowed.");
            echo json_encode($response);
            exit;
        }
    } else {
        $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "Profile image is required.");
        echo json_encode($response);
        exit;
    }

    // if (empty($firstname) || empty($lastname) || empty($gender) || empty($dateofbirth) || empty($height) || empty($maritalstatus) || empty($religion) || empty($religionlookingfor) || empty($nationality) || empty($nationalitylookingfor) || empty($education) || empty($educationlookingfor) || empty($city) || empty($citylookingfor) || empty($cast) || empty($castlookingfor) || empty($subcast) || empty($subcastlookingfor) || empty($sect) || empty($sectlookingfor) || empty($subsect) || empty($subsectlookingfor) || empty($ethnicity) || empty($ethnicitylookingfor)) {
    //     $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "Please fill in all the fields.");
    //     echo json_encode($response);
    //     exit;
    // }

    $timestamp = date("Y-m-d H:i:s");

    $query = "INSERT INTO register (
        firstname, lastname, gender, dateofbirth, height, maritalstatus, religion, religionlookingfor, nationality, nationalitylookingfor,
        education, educationlookingfor, city, citylookingfor, cast, castlookingfor, subcast, subcastlookingfor, sect, sectlookingfor,
        subsect, subsectlookingfor, ethnicity, ethnicitylookingfor, profileimage, created_at
    ) VALUES (
        '$firstname', '$lastname', '$gender', '$dateofbirth', '$height', '$maritalstatus', '$religion', '$religionlookingfor', '$nationality', '$nationalitylookingfor',
        '$education', '$educationlookingfor', '$city', '$citylookingfor', '$cast', '$castlookingfor', '$subcast', '$subcastlookingfor', '$sect', '$sectlookingfor',
        '$subsect', '$subsectlookingfor', '$ethnicity', '$ethnicitylookingfor', '$profileImageUrl', '$timestamp'
    )";

    if (mysqli_query($conn, $query)) {

        $userId = mysqli_insert_id($conn);

        $response = array(
            "ResponseCode" => "200",
            "Result" => "true",
            "ResponseMsg" => "Registration successful!",
            "userid" => $userId 
        );
        echo json_encode($response);
    } else {
        $response = array("ResponseCode" => "500", "Result" => "false", "ResponseMsg" => "Error while inserting data into the database.");
        echo json_encode($response);
    }
} else {
    $response = array("ResponseCode" => "405", "Result" => "false", "ResponseMsg" => "Method not allowed. Only POST requests are allowed.");
    echo json_encode($response);
}
?>
